## debmake-doc 1.17

=== Makefile ===
# Build all Debian packaging examples and produce documentation
# Copyright (C) 2015 Osamu Aoki

.PHONY: all build clean distclean
# build document
all: build

# run "make prep" before "make log" to keep example package source tree consistent
# run "make logs" before "make all" to make logs for building example packages
# make sure to commit logs to the git repository as a part of the document source

# Normalize build environment (Debian default is LANG=C etc.)
LC_ALL := C.UTF-8
export LC_ALL

# Used as $(call check-command, <command>, <package>)
define check-command
set -e; if ! which $(1) >/dev/null; then \
  echo "Missing command: $(1), install package: $(2)"; \
  false; \
fi
endef

#######################################################################
# Document translation strategy: use po4a
# 1. Generate $(BASEXML) using AsciiDoc with docbook4 backend
#    (Ease of writing main contents)
# 2. Make docbook 5 source $(MANUAL).en.x01 with db4-upgrade.xsl
# 3. Write the info header section as $(HEADXML)
# 4. Merge $(HEADXML) and $(MANUAL).en.x01 as $(MANUAL).en.x02
# 5. Generate po/$(MANUAL).pot from $(MANUAL).en.x02 with po4a
# 6. Translate po/$(MANUAL).pot and create po/<lang>.po
# 7. Generate $(MANUAL).<lang>.x02 from $(MANUAL).en.x02 and po/<lang>.po
#    using po4a
# 8. Make $(MANUAL).<lang>.xml from $(MANUAL).<lang>.x02
# 9. Build html, ... from $(MANUAL).<lang>.xml
#######################################################################
# Build documentation
MANUAL	:= debmake-doc
DEBEMAIL := osamu@debian.org
DEBFULLNAME := "Osamu Aoki"
ASCIIDOC_DIR := asciidoc
BASEXML := $(ASCIIDOC_DIR)/$(MANUAL).xml
HEADXML := $(ASCIIDOC_DIR)/head.txt
XSLT_DIR := xslt
BASEDIR := $(CURDIR)/basedir
TMPDIR := $(CURDIR)/tmp

# languages translated with PO files (not used now)
LANGPO ?= ja zh-cn zh-tw de ru
# languages to skip generation of PDF files (not used now)
NOPDF ?=
# languages to build document
LANGALL := en $(LANGPO)
SRC_PO := $(addsuffix .po, $(addprefix  po4a/po/, $(LANGPO)))
SRC_X02 := $(addsuffix .x02, $(addprefix  $(MANUAL)., $(LANGPO)))
SRC_XML := $(addsuffix .xml, $(addprefix  $(MANUAL)., $(LANGALL)))
#######################################################################
# Build time determined text
# version of the debmake command used
DEBMAKEVERSION := $(shell cat examples/debhello-0.0_build-1/step999.slog)
# version of this Debian package (debian/changelog)
DEBVERSION ?= $(shell { dpkg-parsechangelog -SVersion || echo "vcs-0.0" ; })
# short date of this Debian package (debian/changelog)
DEBDATE ?= $(shell { date --utc +'%Y-%m-%d' -d"`dpkg-parsechangelog -SDate`" || date +'(No changelog) %Y-%m-%d' ; })
# debhelper compat = debhelper major version
DHCOMPAT ?= $(shell { dpkg-query -f'$${source:Version}' -W debhelper|sed 's/\..*$$//' ; })
#######################################################################
# Constants for asciidoc -> xml -> any conversion
# Program name and option
XSLT := xsltproc --novalid --nonet --xinclude
MKDIRP := mkdir -p
MSGCAT := msgcat
MSGFMT := msgfmt
MSGMERGE := msgmerge --update --previous
MSGATTRIB := msgattrib
DBLATEX	:= dblatex
# Change $(DRAFTMODE) from "yes" to "maybe" when this document
# should go into production mode
#export DRAFTMODE := yes
export DRAFTMODE := maybe
#######################################################################

build: $(wildcard $(ASCIIDOC_DIR)/*.txt)
	: # ========================== BUILD DOCS =============================
	# process ASCIIDOC after $(pkg) targets even under the parallel build
	$(MAKE) base-xml
	echo "LC_ALL='$(LC_ALL)'"
	echo "LANGPO='$(LANGPO)'"
	echo "LANGALL='$(LANGALL)'"
	echo "NOPDF='$(NOPDF)'"
	echo "BASEDIR='$(BASEDIR)'"
	echo "TMPDIR='$(TMPDIR)'"
	$(MAKE) all-xml	                # XML docs for all PO
	-mkdir -p $(TMPDIR)
	-mkdir -p $(BASEDIR)/html
	# leave fuzzy status in the package build log
	-cat fuzzy.log
	$(MAKE) css
	$(MAKE) html
	$(MAKE) txt
	$(MAKE) pdf
	$(MAKE) epub

clean:
	: # ========================== CLEAN SOURCE ===========================
	echo "LC_ALL='$(LC_ALL)'"
	echo "NOPDF='$(NOPDF)'"
	echo "BASEDIR='$(BASEDIR)'"
	echo "TMPDIR='$(TMPDIR)'"
	-rm -rf $(TMPDIR)
	-$(MAKE) -C $(ASCIIDOC_DIR) clean

distclean: clean

dbk:
	-mkdir -p $(TMPDIR)
	-mkdir -p $(BASEDIR)/html
	$(MAKE) -C $(ASCIIDOC_DIR) xml
	$(MAKE) css html

.PHONY: dbk

#######################################################################
# Normal doc content as English base xml
$(BASEXML): $(wildcard $(ASCIIDOC_DIR)/*.txt)
	$(MAKE) -C $(ASCIIDOC_DIR) xml	# base XML doc

# set last chapter as appendix.
$(MANUAL).en.x01: $(BASEXML)
	@$(call check-command, xsltproc, xsltproc)
	$(XSLT) $(XSLT_DIR)/modappendix.xsl $< > $@

# header is manually written and main content is generated from asciidoc
$(MANUAL).en.x02: $(MANUAL).en.x01 $(HEADXML)
	cat $(HEADXML) > $@
	sed -e '1,/<\/bookinfo>/d' $(MANUAL).en.x01 >> $@

$(MANUAL).po.stamp: $(MANUAL).en.x02 $(SRC_PO)
	-mkdir -p $(TMPDIR)
	po4a -v po4a/po4a.cfg

$(SRC_X02): $(MANUAL).po.stamp

fuzzy.log: $(SRC_X02)
	: > fuzzy.log
	for lang in $(LANGPO); do \
	MESS1="no-obsolete  $$lang  `$(MSGATTRIB) --no-obsolete  po4a/po/$$lang.po |grep ^msgid |sed 1d|wc -l`";\
	MESS2="untranslated $$lang  `$(MSGATTRIB) --untranslated po4a/po/$$lang.po |grep ^msgid |sed 1d|wc -l`";\
	MESS3="fuzzy        $$lang  `$(MSGATTRIB) --fuzzy        po4a/po/$$lang.po |grep ^msgid |sed 1d|wc -l`";\
	echo "$$MESS1" >>fuzzy.log ; \
	echo "$$MESS2" >>fuzzy.log ; \
	echo "$$MESS3" >>fuzzy.log ; \
	echo "" >>fuzzy.log ; \
	done

$(MANUAL).%.xml: $(MANUAL).%.x02
	sed \
	-e "s/@@@debmakeversion@@@/$(DEBMAKEVERSION)/g" \
	-e "s/@@@debversion@@@/$(DEBVERSION)/g" \
	-e "s/@@@debdate@@@/$(DEBDATE)/g" \
	-e "s/@@@dhcompat@@@/$(DHCOMPAT)/g" \
	< $^ > $@

.FORCE:
	echo "FORCE"

doc-clean:
	-rm -f *.swp *~ *.tmp
	-rm -f po4a/po/*~
	-rm -rf $(TMPDIR)
	-rm -rf $(BASEDIR)
	-rm -rf $(LANGALL)
	-rm -r $(MANUAL).po.stamp
	-rm -f $(addsuffix .x00, $(addprefix $(MANUAL)., $(LANGALL)))
	-rm -f $(addsuffix .x01, $(addprefix $(MANUAL)., $(LANGALL)))
	-rm -f $(addsuffix .x02, $(addprefix $(MANUAL)., $(LANGALL)))
	-rm -f $(addsuffix .xml, $(addprefix $(MANUAL)., $(LANGALL)))
	-rm -f fuzzy.log

clean: doc-clean

#######################################################################
.PHONY: base-xml
base-xml: $(BASEXML)

#######################################################################
.PHONY: po
po: $(MANUAL).po.stamp

#######################################################################
.PHONY: all-xml
all-xml: $(SRC_XML) $(ENT_ALL)

#######################################################################
.PHONY: doc-all
doc-all: css html txt epub

#######################################################################
# $ make test      # build html for testing (for Translator)
#######################################################################
.PHONY: doc-test
doc-test: html css

#######################################################################
# $ make wrap       # wrap all PO
#######################################################################
.PHONY: wrap nowrap wip
wrap:
	@$(call check-command, msgcat, gettext)
	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
	$(MSGCAT) -o $$XX $$XX ;\
	done
nowrap:
	@$(call check-command, msgcat, gettext)
	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
	$(MSGCAT) -o $$XX --no-wrap $$XX ;\
	done

wip:
	@$(call check-command, msgattrib, gettext)
	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
	$(MSGATTR) -o $$XX.fuzz --fuzzy        $$XX ;\
	$(MSGATTR) -o $$XX.untr --untranslated $$XX ;\
	done

#######################################################################
# $ make css       # update CSS and DIMG in $(BASEDIR)
#######################################################################
.PHONY: css
css:
	-rm -rf $(BASEDIR)/html/images
	mkdir -p $(BASEDIR)/html/images
	cp -f $(XSLT_DIR)/debian.css $(BASEDIR)/html/debian.css
	echo "AddCharset UTF-8 .txt" > $(BASEDIR)/html/.htaccess
	cd png ; \
	cp caution.png home.png important.png next.png note.png \
		prev.png tip.png warning.png $(BASEDIR)/html/images

#######################################################################
# $ make html      # update all HTML in $(BASEDIR)
#######################################################################
.PHONY: html
html:	$(foreach LX, $(LANGALL), $(BASEDIR)/html/index.$(LX).html) fuzzy.log
	cat fuzzy.log

$(BASEDIR)/html/index.%.html: $(MANUAL).%.xml
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(BASEDIR)/html
	$(XSLT) --stringparam base.dir $(BASEDIR)/html \
                --stringparam html.ext .$*.html \
                $(XSLT_DIR)/style-html.xsl $<

#######################################################################
# $ make txt       # update all Plain TEXT in $(BASEDIR)
#######################################################################
.PHONY: txt
txt:	$(foreach LX, $(LANGALL), $(BASEDIR)/$(MANUAL).$(LX).txt.gz)

# style-txt.xsl provides work around for hidden URL links by appending them explicitly.
$(BASEDIR)/$(MANUAL).%.txt.gz: $(MANUAL).%.xml
	@$(call check-command, w3m, w3m)
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(BASEDIR)
	@test -n "`which w3m`"  || { echo "ERROR: w3m not found. Please install the w3m package." ; false ;  }
	$(XSLT) $(XSLT_DIR)/style-txt.xsl $< | LC_ALL=C.UTF-8 \
	  w3m -o display_charset=UTF-8 -cols 70 -dump -no-graph -T text/html | \
	  gzip -n -9 - > $@


#######################################################################
# $ make pdf       # update all PDF in $(BASEDIR)
#######################################################################
.PHONY: pdf nopdf
pdf:	$(foreach LX, $(LANGALL), $(BASEDIR)/$(MANUAL).$(LX).pdf)

nopdf: $(TMPDIR)/nopdf.pdf

$(TMPDIR)/nopdf.pdf: nopdf.tex
	cp -f nopdf.tex $(TMPDIR)/nopdf.tex
	cd "$(TMPDIR)"; \
	xelatex nopdf.tex

$(foreach LX, $(NOPDF), $(BASEDIR)/$(MANUAL).$(LX).pdf): $(TMPDIR)/nopdf.pdf
	cp $(TMPDIR)/nopdf.pdf $@


# dblatex.xsl provide work around for hidden URL links by appending them explicitly.
$(BASEDIR)/$(MANUAL).%.pdf: $(MANUAL).%.xml
	@$(call check-command, dblatex, dblatex)
	@$(call check-command, xsltproc, xsltproc)
	-mkdir -p $(BASEDIR)
	@test -n "`which $(DBLATEX)`"  || { echo "ERROR: dblatex not found. Please install the dblatex package." ; false ;  }
	export TEXINPUTS=".:"; \
	export TMPDIR="$(TMPDIR)"; \
	$(XSLT) $(XSLT_DIR)/dblatex.xsl $<  | \
	$(DBLATEX) --style=db2latex \
		--debug \
		--backend=xetex \
		--xsl-user=$(XSLT_DIR)/user_param.xsl \
		--xsl-user=$(XSLT_DIR)/xetex_param.xsl \
		--param=draft.mode=$(DRAFTMODE) \
		--param=doc.collab.show=0 \
		--param=latex.output.revhistory=0 \
		--param=doc.lot.show="" \
		--param=lingua=$* \
		--output=$@ - || { echo "OMG!!!!!! XXX_CHECK_XXX ... Do not worry ..."; true ; }

#######################################################################
# $ make tex       # update all TeX source in $(BASEDIR)
#######################################################################
.PHONY: tex
tex:	$(foreach LX, $(LANGALL), $(BASEDIR)/$(MANUAL).$(LX).tex)

# dblatex.xsl provide work around for hidden URL links by appending them explicitly.
$(BASEDIR)/$(MANUAL).%.tex: $(MANUAL).%.xml
	-mkdir -p $(BASEDIR)
	@test -n "`which $(DBLATEX)`"  || { echo "ERROR: dblatex not found. Please install the dblatex package." ; false ;  }
	export TEXINPUTS=".:"; \
	export TMPDIR="$(TMPDIR)"; \
	$(XSLT) $(XSLT_DIR)/dblatex.xsl $<  | \
	$(DBLATEX) --style=native \
		--debug \
		--type=tex \
		--backend=xetex \
		--xsl-user=$(XSLT_DIR)/user_param.xsl \
		--xsl-user=$(XSLT_DIR)/xetex_param.xsl \
		--param=draft.mode=$(DRAFTMODE) \
		--param=doc.collab.show=0 \
		--param=latex.output.revhistory=0 \
		--param=doc.lot.show="" \
		--param=lingua=$* \
		--output=$@ - || { echo "OMG!!!!!! XXX_CHECK_XXX ... Do not worry ..."; true ; }

#######################################################################
# $ make epub      # update all epub in $(BASEDIR)

=== examples/Makefile ===
# Build all Debian packaging examples
# Copyright (C) 2021 Osamu Aoki

# Normalize build environment (Debian default is LANG=C etc.)
LC_ALL := C.UTF-8
export LC_ALL
TERM = dumb
export TERM
ARCH := $(shell dpkg-architecture -q DEB_TARGET_ARCH)

ALL_DIRS := $(shell find . -maxdepth 1 -type d -regex '\./debhello-.*' | sed  -e 's,^\./,,')
BUILD_DIRS := $(shell find . -maxdepth 1 -type d -regex '\./debhello-.*_build.*' | sed  -e 's,^\./,,')
UPSTREAM_DIRS := $(filter-out $(BUILD_DIRS),$(ALL_DIRS))
TARGZS := $(addsuffix .tar.gz, $(UPSTREAM_DIRS))
ORIGTARGZS := $(patsubst debhello-%,debhello_%,$(addsuffix .orig.tar.gz, $(UPSTREAM_DIRS)))
BUILDMAKEFILES := $(addsuffix /Makefile, $(BUILD_DIRS))
BUILDSTAMPS := $(addsuffix -stamp, $(BUILD_DIRS))

all: prep
	# === BUILDSTAMPS ===
	$(MAKE) $(BUILDSTAMPS)
	# === SUCCESS ALL ===
prep:
	# === ALL_DIRS ===
	@ echo "$(ALL_DIRS)"| xargs -n1
	# === BUILD_DIRS ===
	@ echo "$(BUILD_DIRS)"| xargs -n1
	# === UPSTREAM_DIRS ===
	@ echo "$(UPSTREAM_DIRS)" | xargs -n1
	# === TARGZS ===
	@ echo "$(TARGZS)" | xargs -n1
	$(MAKE) $(TARGZS)
	# === ORIGTARGZS ===
	@ echo "$(ORIGTARGZS)" | xargs -n1
	$(MAKE) $(ORIGTARGZS)
	# === BUILDMAKEFILES ===
	$(MAKE) $(BUILDMAKEFILES)
	# === SUCCESS PREP ===
clean:
	-rm -f $(TARGZS)
	-rm -f $(ORIGTARGZS)
	-rm -f $(BUILDMAKEFILES)
	-rm -f $(BUILDSTAMPS)
	# way to clean build results and Makefile link
	-rm -f debhello-*_build*/*.log
	-rm -f debhello-*_build*/Makefile
	-rm -f debhello-*_build*/next.dir
	-rm -f debhello-*_build*/project
	-rm -rf debhello-*_build*/test
	# post-debmake snapshot of test
	-rm -rf debhello-*_build*/debmake
	# post-package snapshot of test
	-rm -rf debhello-*_build*/package

distclean: clean
	-rm -f debhello-*_build*/*.slog

debhello-%.tar.gz: debhello-%/LICENSE
	tar --exclude=debhello-$*/debian -cvzf $@ debhello-$*/

debhello_%.orig.tar.gz: debhello-%.tar.gz
	ln -sf $^ $@

debhello-%/Makefile: template/Makefile
	ln -sf ../$^ $@

debhello-%-stamp: debhello-%/Makefile
	$(MAKE) -C debhello-$*

#######################################################################
# Groom debhello-*/debian/* template files
#######################################################################
VERSIONS := $(patsubst debhello-%,%,$(UPSTREAM_DIRS))
CHANGELOGS := $(addsuffix /debian/changelog, $(addprefix debhello-,$(VERSIONS)))
COPYRIGHTS := $(addsuffix /debian/copyright, $(addprefix debhello-,$(VERSIONS)))
COPYRIGHTS := $(addsuffix /debian/control, $(addprefix debhello-,$(VERSIONS)))
READMES := $(addsuffix /debian/README.Debian, $(addprefix debhello-,$(VERSIONS)))
WATCHS := $(addsuffix /debian/watch, $(addprefix debhello-,$(VERSIONS)))
SRCF := $(addsuffix /debian/source/format, $(addprefix debhello-,$(VERSIONS)))
WRAPS := $(addsuffix -wrap,$(addprefix debhello-,$(VERSIONS)))

vers:
	# === VERSIONS ===
	@ echo "$(VERSIONS)"| xargs -n1

groom:
	cd template ; touch * source/*
	$(MAKE) $(CHANGELOGS) $(COPYRIGHTS) $(READMES) $(WATCHS) $(SRCF) $(CONTROLS)
	# clean whitespaces in line tail (exclude some directories)
	-find . -type d \
		-regex ".*/\.git" -prune -o \
		-regex ".*/post-gettextize" -prune -o \
		-regex ".*/png" -prune -o \
	       -type f -exec sed -i -e 's/[ \t]*$$//' '{}' \;
	$(MAKE) $(WRAPS)

debhello-%/debian/changelog: template/changelog
	mkdir -p debhello-$*/debian
	sed -ne '/debhello ($*-1/,$$p' <$^ >$@

debhello-%/debian/copyright: template/copyright
	mkdir -p debhello-$*/debian
	cp -f $^ $@

# Standards-Version: 4.5.1
# Homepage: <insert the upstream URL, if relevant>
# Homepage: https://salsa.debian.org/debian/debmake-doc
# Vcs-Git: https://salsa.debian.org/debian/debmake-doc.git
# Vcs-Browser: https://salsa.debian.org/debian/debmake-doc
HOMEPAGE = https://salsa.debian.org/debian/debmake-doc
STDVER = 4.5.1
DHCOMPAT = 13
MAINTNM = Osamu Aoki <osamu@debian.org>

debhello-%/debian/control: template/README.Debian
	mkdir -p debhello-$*/debian
	sed -i  \
		-e 's/^Section: unknown$$/Section: devel/' \
		-e 's/^Maintainer:.*$$/Maintainer: $(MAINTNM)/' \
		-e 's/debhelper-compat *( *= *[1-9][0-9]* *)/debhelper-compat (= $(DHCOMPAT))/' \
		-e 's/^Standards-Version:.*$$/Standards-Version: $(STDVER)/' \
		-e 's,^Homepage:.*$$,Homepage: $(HOMEPAGE),' \
		-e 's,^Description:.*$$,Description: Simple packaging example for debmake,' \
		-e 's,was auto-generated.*$$,is an example package.,' \
		-e 's,^ debmake(1) command provided by .*$$, (This is an example only),' \
		-e 's,^X-Python3-Version.*$$,,' \
		$@

debhello-%/debian/README.Debian: template/README.Debian
	mkdir -p debhello-$*/debian
	cp -f $^ $@

debhello-%/debian/watch: template/watch
	mkdir -p debhello-$*/debian
	cp -f $^ $@

debhello-%/debian/source/format: template/source/format
	mkdir -p debhello-$*/debian/source
	cp -f $^ $@

debhello-%-wrap:
	cd debhello-$* ; \
	wrap-and-sort

=== examples/debhello-0.3/Makefile ===
all: src/hello

src/hello: src/hello.c
	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDCFLAGS) -o $@ $^

install: src/hello
	install -D src/hello \
		/usr/local/bin/hello

clean:
	-rm -f src/hello

distclean: clean

uninstall:
	-rm -f /usr/local/bin/hello

.PHONY: all install clean distclean uninstall

=== examples/debhello-3.0/Makefile ===
prefix = /usr/local

all:
	$(MAKE)  -C po all

install: all
	install -D scripts/hello $(DESTDIR)/$(prefix)/bin/hello
	install -m 644 -D data/hello.desktop \
		$(DESTDIR)$(prefix)/share/applications/hello.desktop
	install -m 644 -D data/hello.png \
		$(DESTDIR)$(prefix)/share/pixmaps/hello.png
	install -m 644 -D man/hello.1 \
		$(DESTDIR)$(prefix)/share/man/man1/hello.1
	install -m 644 -D po/ja.mo \
		$(DESTDIR)$(prefix)/share/locale/ja/LC_MESSAGES/debhello.mo

clean:
	$(MAKE)  -C po clean

distclean: clean

uninstall:
	-rm -f $(DESTDIR)$(prefix)/bin/hello
	-rm -f $(DESTDIR)$(prefix)/share/applications/hello.desktop
	-rm -f $(DESTDIR)$(prefix)/share/pixmaps/hello.png
	-rm -f $(DESTDIR)$(prefix)/share/man/man1/hello.1
	-rm -f $(DESTDIR)$(prefix)/share/locale/ja/LC_MESSAGES/debhello.mo

.PHONY: all install clean distclean uninstall

=== examples/debhello-3.4/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)
project(debhello)
set(PACKAGE_AUTHOR "Osamu Aoki")
add_subdirectory(po)
add_subdirectory(lib)
add_subdirectory(src)
add_subdirectory(man)
add_subdirectory(data)

=== examples/template/Makefile ===
# Generic build script
DEBEMAIL:=email.address@example.org
DEBFULLNAME:="Firstname Lastname"
export DEBEMAIL DEBFULLNAME
ROOTDIR:=$(CURDIR)
# package build work directory
TESTDIR:=$(CURDIR)/test
# parent directory
COMMONDIR:=$(abspath $(CURDIR)/..)
PATH := $(COMMONDIR)/bin:$(PATH)
PROJECT:=$(shell echo $(notdir $(CURDIR))|sed -e 's/_build-[0-9]*$$//' )
PROJECTDIR:=$(TESTDIR)/$(PROJECT)
TERM:=xterm
TREE_COLORS:=
LS_COLORS:=
CDPATH:=
NOANSI:=s/\x1B\[([0-9]{1,2}(;[0-9]{1,2})?)?[m|K]//g
FILTER :=s/\(^.............................................................................\).*$$/\1.../
TGZ:=tar.gz
export ROOTDIR TESTDIR COMMONDIR PATH PROJECT PROJECTDIR TREE_COLORS LS_COLORS TERM CDPATH TGZ

stepcmds := $(sort $(wildcard *.cmd))
steps := $(patsubst %.cmd, %, $(stepcmds))

all:
	mkdir -p $(TESTDIR)
	echo $(ROOTDIR) > $(ROOTDIR)/next.dir
	echo $(PROJECT) > $(ROOTDIR)/project
	for i in $(steps) ; do \
	cd $$(cat $(ROOTDIR)/next.dir) >/dev/null ; \
	script -e -q -c $(ROOTDIR)/$$i.cmd $(ROOTDIR)/$$i.log ; \
	ERR=$$? ; \
	cat $(ROOTDIR)/$$i.log | col -b -x | \
	grep -v -e '^Script started on' | \
	grep -v -e '^Script done on' | \
	sed -r '$(NOANSI)' | \
	sed -e 's#$(TESTDIR)#/path/to#g' | \
	sed -e '$(FILTER)' > $(ROOTDIR)/$$i.slog ; \
	if [ x$$ERR != x0 ]; then exit 1 ; fi ; \
	done

clean:
	-rm -rf $(TESTDIR)
	-rm -rf debmake
	-rm -rf package
	-rm -f .stamp
	-rm -f *.log
	-rm -rf next.dir project

distclean: clean
	-rm -f *.slog
	-rm -f *.patch

step%.raw: step%.cmd
	./$^ >$@


check:
	@echo "TESTDIR=$(TESTDIR)"
	@echo "PROJECT=$(PROJECT)"

.PHONY: all clean distclean check

=== examples/debhello-2.1/lib/CMakeLists.txt ===
add_library(sharedlib SHARED sharedlib.c)
# CMake will link the executables and shared libraries with full RPATH to all
# used libraries in the build tree by default. When installing, it will clear
# the RPATH of these targets so they are installed with an empty RPATH.
set_property(TARGET sharedlib PROPERTY VERSION "1.0.0")
set_property(TARGET sharedlib PROPERTY SOVERSION 1 )
install(TARGETS sharedlib LIBRARY DESTINATION lib)
install(FILES sharedlib.h DESTINATION include)

=== examples/debhello-3.0/po/Makefile ===
all: ja.mo ../data/hello.desktop

pot: debhello.pot

debhello.pot: ../scripts/hello ../data/hello.desktop.in
	xgettext -d debhello -L desktop ../data/hello.desktop.in -o $@
	xgettext -d debhello -j -L shell ../scripts/hello -o $@

%.po: debhello.pot FORCE
	msgmerge -U $@ debhello.pot

%.mo: %.po
	msgfmt $< -o $@

../data/hello.desktop: ../data/hello.desktop.in
	msgfmt --desktop --template $< -d ./ -o $@

clean:
	-rm -f *.mo *~
	-rm -f ../data/hello.desktop

FORCE:

=== examples/debhello-3.4/po/CMakeLists.txt ===
include(FindGettext)
if(GETTEXT_FOUND)
  set(_potFile ${CMAKE_BINARY_DIR}/po/${PROJECT_NAME}.pot)
  # program source file
  set(_src_list
    ${CMAKE_SOURCE_DIR}/src/hello.c
    ${CMAKE_SOURCE_DIR}/lib/sharedlib.c
  )
  add_custom_command(
    OUTPUT ${_potFile}
    COMMAND touch ${_potFile}
    COMMAND xgettext -o ${_potFile} ${_src_list}
    COMMAND xgettext -L Desktop -j -o ${_potFile} ${CMAKE_SOURCE_DIR}/data/hello.desktop.in
    DEPENDS ${_src_list} ${CMAKE_SOURCE_DIR}/data/hello.desktop.in
    WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
  )
  add_custom_target(pot ALL
    DEPENDS ${_potFile}
  )
  # Create a target "translations" and output mo files.
  gettext_create_translations(${_potFile} ALL ja.po)
  #gettext_process_pot_file(${_potFile} ALL ja)
  set(_desktopinFile ${CMAKE_SOURCE_DIR}/data/hello.desktop.in)
  set(_desktopFile ${CMAKE_BINARY_DIR}/data/hello.desktop)
  add_custom_command(
    OUTPUT ${_desktopFile}
    COMMAND ${GETTEXT_MSGFMT_EXECUTABLE} --desktop -o ${_desktopFile} --template=${_desktopinFile} -d .
    DEPENDS ${_desktopFile} ja.po
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  )
  add_custom_target(desktop ALL
    DEPENDS ${_desktopFile}
  )
  install(FILES ${_desktopFile}
    DESTINATION share/applications
  )
endif(GETTEXT_FOUND)

=== examples/debhello-3.4/src/CMakeLists.txt ===
# Always define HAVE_CONFIG_H
add_definitions(-DHAVE_CONFIG_H)
# Generate config.h from config.h.in
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h"
)
include_directories("${CMAKE_CURRENT_BINARY_DIR}")
include_directories("${CMAKE_SOURCE_DIR}/lib")

add_executable(hello hello.c)
target_link_libraries(hello sharedlib)
target_link_libraries(hello ${GETTEXT_LIBRARIES})
install(TARGETS hello
  RUNTIME DESTINATION bin)

=== debian/changelog ===
debmake-doc (1.17-4) unstable; urgency=medium

  * Pull DE translation.
  * Bump policy version

 -- Osamu Aoki <osamu@debian.org>  Sun, 21 Nov 2021 15:03:58 +0900

debmake-doc (1.17-3) unstable; urgency=medium

  * Update copyright to 2021
  * Fix typo.  Thanks Daichi Fukui.  Closes: Bug#1000256

 -- Osamu Aoki <osamu@debian.org>  Fri, 27 Aug 2021 14:31:19 +0900

debmake-doc (1.17-2) unstable; urgency=medium

  * Explicitly mention apt-pinning etc.
  * Mention how-can-i-help.
  * epub: Reproducible build

 -- Osamu Aoki <osamu@debian.org>  Fri, 27 Aug 2021 11:04:45 +0900

debmake-doc (1.17-1) unstable; urgency=medium

  * Switch from pbuilder to sbuild
  * More on source-only-upload
  * Remove debian/source/include-binaries
  * Add missing LICENSE
  * Move examples generation under examples/
  * Adjust for new directory names
  * Drop useless faketime
  * Add new examples/Makefile
  * Add examples/README.md
  * Adjust for new examples location
  * Update examples/README.md
  * Conversion to setuptools
  * Regenerate example log
  * Update debian/source/patch-header
  * Add autopkgtest

 -- Osamu Aoki <osamu@debian.org>  Thu, 19 Aug 2021 17:59:15 +0900

debmake-doc (1.16-2) unstable; urgency=medium

  * Reactivate translator credits via po4a addendum mechanism.
  * Translation updates for Chinese and German.

 -- Osamu Aoki <osamu@debian.org>  Sun, 11 Apr 2021 08:27:49 +0900

=== debian/control ===
Source: debmake-doc
Section: doc
Priority: optional
Maintainer: Osamu Aoki <osamu@debian.org>
Build-Depends: asciidoc,
               dblatex,
               debhelper-compat (= 13),
               dh-python,
               docbook-xml,
               docbook-xsl,
               fonts-arphic-bsmi00lp,
               fonts-arphic-gbsn00lp,
               fonts-ipafont,
               fonts-liberation,
               fonts-wqy-zenhei,
	       po4a,
               latex-cjk-all,
               libxml2-utils,
               lmodern,
               locales-all | locales,
               texlive,
               texlive-lang-chinese,
               texlive-lang-cyrillic,
               texlive-lang-english,
               texlive-lang-french,
               texlive-lang-german,
               texlive-lang-japanese,
               texlive-xetex,
               xsltproc,
	       w3m,
               zip
Standards-Version: 4.6.0
Homepage: https://salsa.debian.org/debian/debmake-doc
Vcs-Git: https://salsa.debian.org/debian/debmake-doc.git
Vcs-Browser: https://salsa.debian.org/debian/debmake-doc

Package: debmake-doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Recommends: debmake
Suggests: debian-policy, developers-reference
Description: Guide for Debian Maintainers
 This tutorial document describes the building of the Debian
 package to ordinary Debian users and prospective developers using
 the debmake command.
 .
 It is focused on the modern packaging style and comes with many
 simple examples.
  * POSIX shell script packaging
  * Python3 script packaging
  * C with Makefile/Autotools/CMake
  * multiple binary package with shared library etc.
 .
 This package can be considered as the successor to the
 maint-guide package.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1

# quilt output is affected by locale; setting explicitly
LC_ALL := C.UTF-8
export LC_ALL

# translation for package (Override Makefile.dbk)
# un-comment to skip building PDF for all
#export NOPDF := en ru zh-cn de ja

# UTF-8 locale
export LC_ALL:= C.UTF-8

%:
	dh $@

override_dh_compress:
	dh_compress -X.pdf

## debmake-doc 1.20

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,17 @@
 # Build all Debian packaging examples and produce documentation
 # Copyright (C) 2015 Osamu Aoki
+# vim: set ts=8 sw=8 noet:
 
 .PHONY: all build clean distclean
 # build document
 all: build
 
-# run "make prep" before "make log" to keep example package source tree consistent
-# run "make logs" before "make all" to make logs for building example packages
-# make sure to commit logs to the git repository as a part of the document source
+# Before building this documentation, you need to update examples/ directory
+# setup and start bash inside sid-chroot
+# move into "examples/" with "cd examples"
+#   update Makefile and run "make groom"
+#   run "make" to update *.slog
+#   commit changes "git commit -a"
 
 # Normalize build environment (Debian default is LANG=C etc.)
 LC_ALL := C.UTF-8
@@ -40,20 +44,25 @@
 DEBEMAIL := osamu@debian.org
 DEBFULLNAME := "Osamu Aoki"
 ASCIIDOC_DIR := asciidoc
-BASEXML := $(ASCIIDOC_DIR)/$(MANUAL).xml
+BASEXML := $(ASCIIDOC_DIR)/$(MANUAL).xml1
 HEADXML := $(ASCIIDOC_DIR)/head.txt
 XSLT_DIR := xslt
 BASEDIR := $(CURDIR)/basedir
 TMPDIR := $(CURDIR)/tmp
+# set SOURCE_DATE_EPOCH if unset (when not called from debhelper)
+SOURCE_DATE_EPOCH ?= $(shell dpkg-parsechangelog -STimestamp || date -R -u)
+# date in changelog
+SOURCE_DATE := $(shell date -u +'%F %T %Z' --date=@$(SOURCE_DATE_EPOCH))
 
 # languages translated with PO files (not used now)
-LANGPO ?= ja zh-cn zh-tw de ru
+LANGPO ?= ja zh-cn zh-tw de ru pt
 # languages to skip generation of PDF files (not used now)
 NOPDF ?=
 # languages to build document
 LANGALL := en $(LANGPO)
 SRC_PO := $(addsuffix .po, $(addprefix  po4a/po/, $(LANGPO)))
 SRC_X02 := $(addsuffix .x02, $(addprefix  $(MANUAL)., $(LANGPO)))
+SRC_X03 := $(addsuffix .x03, $(addprefix  $(MANUAL)., $(LANGPO)))
 SRC_XML := $(addsuffix .xml, $(addprefix  $(MANUAL)., $(LANGALL)))
 #######################################################################
 # Build time determined text
@@ -74,6 +83,7 @@
 MSGFMT := msgfmt
 MSGMERGE := msgmerge --update --previous
 MSGATTRIB := msgattrib
+DPO := po4a/po
 DBLATEX	:= dblatex
 # Change $(DRAFTMODE) from "yes" to "maybe" when this document
 # should go into production mode
@@ -109,7 +119,9 @@
 	echo "BASEDIR='$(BASEDIR)'"
 	echo "TMPDIR='$(TMPDIR)'"
 	-rm -rf $(TMPDIR)
+	-rm -rf po4a-tmp
 	-$(MAKE) -C $(ASCIIDOC_DIR) clean
+	-$(MAKE) -C examples clean
 
 distclean: clean
 
@@ -124,25 +136,38 @@
 #######################################################################
 # Normal doc content as English base xml
 $(BASEXML): $(wildcard $(ASCIIDOC_DIR)/*.txt)
-	$(MAKE) -C $(ASCIIDOC_DIR) xml	# base XML doc
+	$(MAKE) -C $(ASCIIDOC_DIR) xml1	# base XML doc (FUll ASCII)
 
 # set last chapter as appendix.
 $(MANUAL).en.x01: $(BASEXML)
 	@$(call check-command, xsltproc, xsltproc)
-	$(XSLT) $(XSLT_DIR)/modappendix.xsl $< > $@
+	$(XSLT) $(XSLT_DIR)/modappendix.xsl $< > $@ # x01: last chapter as appendix/UTF-8
 
 # header is manually written and main content is generated from asciidoc
 $(MANUAL).en.x02: $(MANUAL).en.x01 $(HEADXML)
 	cat $(HEADXML) > $@
-	sed -e '1,/<\/bookinfo>/d' $(MANUAL).en.x01 >> $@
-
-$(MANUAL).po.stamp: $(MANUAL).en.x02 $(SRC_PO)
+	sed -e '1,/<\/info>/d' $(MANUAL).en.x01 >> $@ # x02: add header
+
+# remove <screen>...</screen>
+$(MANUAL).en.x03: $(MANUAL).en.x02
+	@$(call check-command, xsltproc, xsltproc)
+	$(XSLT) $(XSLT_DIR)/screen.xsl $< > $@ # x03: no <screen>
+
+# po4a/po4a-x02.cfg -- on x03 to generate po (no xml)
+$(MANUAL).po-pre.stamp: $(MANUAL).en.x03
 	-mkdir -p $(TMPDIR)
-	po4a -v po4a/po4a.cfg
+	po4a -v po4a/po4a-x03.cfg
+
+# po4a/po4a.cfg -- on x02 to generate xml
+$(MANUAL).po.stamp: $(MANUAL).po-pre.stamp
+	-mkdir -p $(TMPDIR)
+	rm -rf po4a-tmp
+	cp -r po4a po4a-tmp
+	po4a -v po4a-tmp/po4a-x02.cfg
 
 $(SRC_X02): $(MANUAL).po.stamp
 
-fuzzy.log: $(SRC_X02)
+fuzzy.log: $(MANUAL).po-pre.stamp
 	: > fuzzy.log
 	for lang in $(LANGPO); do \
 	MESS1="no-obsolete  $$lang  `$(MSGATTRIB) --no-obsolete  po4a/po/$$lang.po |grep ^msgid |sed 1d|wc -l`";\
@@ -172,9 +197,11 @@
 	-rm -rf $(BASEDIR)
 	-rm -rf $(LANGALL)
 	-rm -r $(MANUAL).po.stamp
+	-rm -r $(MANUAL).po-pre.stamp
 	-rm -f $(addsuffix .x00, $(addprefix $(MANUAL)., $(LANGALL)))
 	-rm -f $(addsuffix .x01, $(addprefix $(MANUAL)., $(LANGALL)))
 	-rm -f $(addsuffix .x02, $(addprefix $(MANUAL)., $(LANGALL)))
+	-rm -f $(addsuffix .x03, $(addprefix $(MANUAL)., $(LANGALL)))
 	-rm -f $(addsuffix .xml, $(addprefix $(MANUAL)., $(LANGALL)))
 	-rm -f fuzzy.log
 
@@ -190,11 +217,11 @@
 
 #######################################################################
 .PHONY: all-xml
-all-xml: $(SRC_XML) $(ENT_ALL)
+all-xml: $(SRC_XML) $(ENT_ALL) fuzzy.log
 
 #######################################################################
 .PHONY: doc-all
-doc-all: css html txt epub
+doc-all: css html txt
 
 #######################################################################
 # $ make test      # build html for testing (for Translator)
@@ -217,11 +244,25 @@
 	$(MSGCAT) -o $$XX --no-wrap $$XX ;\
 	done
 
+# remove obsolete
+wrapx:
+	@$(call check-command, msgcat, gettext)
+	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
+	$(MSGATTRIB) --no-obsolete -o $$XX $$XX ;\
+	done
+
+# remove obsolete
+nowrapx:
+	@$(call check-command, msgcat, gettext)
+	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
+	$(MSGATTRIB) --no-wrap --no-obsolete -o $$XX $$XX ;\
+	done
+
 wip:
 	@$(call check-command, msgattrib, gettext)
 	for XX in $(foreach LX, $(LANGPO), $(DPO)/$(LX).po); do \
-	$(MSGATTR) -o $$XX.fuzz --fuzzy        $$XX ;\
-	$(MSGATTR) -o $$XX.untr --untranslated $$XX ;\
+	$(MSGATTRIB) -o $$XX.fuzz --fuzzy        $$XX ;\
+	$(MSGATTRIB) -o $$XX.untr --untranslated $$XX ;\
 	done
 
 #######################################################################
@@ -294,43 +335,9 @@
 	export TEXINPUTS=".:"; \
 	export TMPDIR="$(TMPDIR)"; \
 	$(XSLT) $(XSLT_DIR)/dblatex.xsl $<  | \
+	sed -e "s/│/|/g"  -e "s/├/+/g" -e "s/─/-/g" -e "s/└/+/g"     | \
 	$(DBLATEX) --style=db2latex \
 		--debug \
 		--backend=xetex \
 		--xsl-user=$(XSLT_DIR)/user_param.xsl \
 		--xsl-user=$(XSLT_DIR)/xetex_param.xsl \
-		--param=draft.mode=$(DRAFTMODE) \
-		--param=doc.collab.show=0 \
-		--param=latex.output.revhistory=0 \
-		--param=doc.lot.show="" \
-		--param=lingua=$* \
-		--output=$@ - || { echo "OMG!!!!!! XXX_CHECK_XXX ... Do not worry ..."; true ; }
-
-#######################################################################
-# $ make tex       # update all TeX source in $(BASEDIR)
-#######################################################################
-.PHONY: tex
-tex:	$(foreach LX, $(LANGALL), $(BASEDIR)/$(MANUAL).$(LX).tex)
-
-# dblatex.xsl provide work around for hidden URL links by appending them explicitly.
-$(BASEDIR)/$(MANUAL).%.tex: $(MANUAL).%.xml
-	-mkdir -p $(BASEDIR)
-	@test -n "`which $(DBLATEX)`"  || { echo "ERROR: dblatex not found. Please install the dblatex package." ; false ;  }
-	export TEXINPUTS=".:"; \
-	export TMPDIR="$(TMPDIR)"; \
-	$(XSLT) $(XSLT_DIR)/dblatex.xsl $<  | \
-	$(DBLATEX) --style=native \
-		--debug \
-		--type=tex \
-		--backend=xetex \
-		--xsl-user=$(XSLT_DIR)/user_param.xsl \
-		--xsl-user=$(XSLT_DIR)/xetex_param.xsl \
-		--param=draft.mode=$(DRAFTMODE) \
-		--param=doc.collab.show=0 \
-		--param=latex.output.revhistory=0 \
-		--param=doc.lot.show="" \
-		--param=lingua=$* \
-		--output=$@ - || { echo "OMG!!!!!! XXX_CHECK_XXX ... Do not worry ..."; true ; }
-
-#######################################################################
-# $ make epub      # update all epub in $(BASEDIR)

=== asciidoc/Makefile ===
# Build 1-page html, manpage, and xml source
# Copyright (C) 2015 Osamu Aoki

# manually copy 1-page html to the people.debian.org
# manually copy manpage to the debmake command
# xml is used to build this package
# This Makefile can function by itself.

# version of the debmake command used
DEBMAKEVERSION ?= $(shell { debmake -v 2>&1 | sed -ne '/^debmake/s/^.*(version: \([0-9.]*\)).*$$/\1/p' ; })
# version of this Debian package (debian/changelog)
DEBVERSION ?= $(shell { cd .. >/dev/null ;dpkg-parsechangelog -SVersion || echo "vcs-0.0" ; })
# short date of this Debian package (debian/changelog)
DEBDATE ?= $(shell { cd .. >/dev/null && date +'%Y-%m-%d' -d"`dpkg-parsechangelog -SDate`" || date +'(No changelog) %Y-%m-%d' ; })

MANUAL := debmake-doc
GENTXT := 90-manpage.txt binary.txt caveat-version.txt
ALLTXT := $(wildcard *.txt) $(GENTXT)

#ASCIIDOC := asciidoc
ASCIIDOC := asciidoctor
# https://docs.asciidoctor.org/asciidoctor/latest/migrate/asciidoc-py/

# These are used as test build target
all:
	$(MAKE) clean
	$(MAKE) man html

test: test.html

html: $(MANUAL).html

# This is used from the parent directory to build debmake-doc
xml: $(MANUAL).xml

xml1: $(MANUAL).xml1

# This is used to make manpage for debmake
# Copy result to debmake
man: debmake.1

check:
	@echo "DEBMAKEVERSION = $(DEBMAKEVERSION)"
	@echo "DEBVERSION     = $(DEBVERSION)"
	@echo "DEBDATE        = $(DEBDATE)"
	@echo "ALLTXT         = $(ALLTXT)"

90-manpage.txt: manpage.txt
	sed -e 's/^= DEBMAKE(1)$$/= *debmake*(1) manpage/' -e 's/^=/==/' $< >$@

binary.txt: manpage.txt
	sed -n -e '/^\*-b\*/,$$p' $< | sed -e '/^\*-e\*/,$$d'> $@

caveat-version.txt: manpage.txt
	sed -e '1,/BEGIN: SNIP_FOR_VERSION/d' $< | sed -e '/END: SNIP_FOR_VERSION/,$$d'> $@

$(MANUAL).xml: $(ALLTXT)
	@$(call check-command, $(ASCIIDOC), $(ASCIIDOC))
	$(ASCIIDOC) --doctype book\
		-b docbook \
		-a 'newline=\n' \
		$(MANUAL).txt

%.xml: %.txt
	@$(call check-command, $(ASCIIDOC), $(ASCIIDOC))
	$(ASCIIDOC) --doctype book\
		-b docbook \
		-a 'newline=\n' \
		$<

%.xml1: %.xml
	./superscript.sh < $< > $@

$(MANUAL).html: $(ALLTXT)
	@$(call check-command, $(ASCIIDOC), $(ASCIIDOC))
	$(ASCIIDOC) --doctype book\
		-b html \
		-a toc2 \
		-a 'newline=\n' \
		$(MANUAL).txt
	sed -i -e "s/@@@dhcompat@@@/13/g" $@

%.html: %.txt
	$(ASCIIDOC) --doctype book\
		-b html \
		-a toc2 \
		-a 'newline=\n' \
		$<

debmake.1: manpage.txt
  ifeq ($(ASCIIDOC), asciidoc)
	a2x --doctype manpage --format manpage \
		manpage.txt
  else
	$(ASCIIDOC) --doctype manpage\
		-b manpage \
		-a 'newline=\n' \
		$<
  endif

clean:
	-rm -f debmake.1 $(GENTXT) $(MANUAL).html

distclean: clean

remote: $(MANUAL).html
	scp $(MANUAL).html people.debian.org:~osamu/public_html/$(MANUAL).html

.PHONY: all xml xml1 html man clean distclean check test remote

=== examples/Makefile ===
# Build all Debian packaging examples
# Copyright (C) 2021 Osamu Aoki

# Standards-Version: 4.6.2
# Homepage: <insert the upstream URL, if relevant>
# Homepage: https://salsa.debian.org/debian/debmake-doc
# Vcs-Git: https://salsa.debian.org/debian/debmake-doc.git
# Vcs-Browser: https://salsa.debian.org/debian/debmake-doc

# Set the followings before "make groom"
HOMEPAGE = https://salsa.debian.org/debian/debmake-doc
STDVER = 4.6.2
DHCOMPAT = 13
MAINTNM = Osamu Aoki <osamu@debian.org>

# vim: set noet ts=8:
# Normalize build environment (Debian default is LANG=C etc.)
LC_ALL := C.UTF-8
export LC_ALL
TERM = dumb
export TERM
ARCH := $(shell dpkg-architecture -q DEB_TARGET_ARCH)

ALL_DEPS := \
            autoconf\
            automake\
            autopoint\
            build-essential \
            cmake\
            debhelper\
            debmake\
            devscripts\
            dh-sequence-single-binary \
            gettext\
            gir1.2-gtk-3.0\
            libltdl-dev\
            libtool\
            libxml2-utils\
            lintian\
            locales-all\
            pybuild-plugin-pyproject \
            python3-all\
            python3-debian\
            python3-gi\
            quilt \
            tree \
            vim\
            w3m\
            zip

ALL_DIRS := $(shell find . -maxdepth 1 -type d -regex '\./debhello-.*' | sed  -e 's,^\./,,')
BUILD_DIRS := $(shell find . -maxdepth 1 -type d -regex '\./debhello-.*_build.*' | sed  -e 's,^\./,,')
UPSTREAM_DIRS := $(filter-out $(BUILD_DIRS),$(ALL_DIRS))
ASCIIDOC_REF := $(addsuffix /ASCIIDOC_REF, $(BUILD_DIRS))
TARGZS := $(addsuffix .tar.gz, $(UPSTREAM_DIRS))
ORIGTARGZS := $(patsubst debhello-%,debhello_%,$(addsuffix .orig.tar.gz, $(UPSTREAM_DIRS)))
BUILDMAKEFILES := $(addsuffix /Makefile, $(BUILD_DIRS))
BUILDSTAMPS := $(addsuffix -stamp, $(BUILD_DIRS))

all:
	# === BUILDSTAMPS ===
	$(MAKE) clean
	$(MAKE) deps
	$(MAKE) prep
	$(MAKE) asciidoc
	$(MAKE) buildall
	# === SUCCESS ALL ===

clean:
	-rm -f $(TARGZS)
	-rm -f $(ORIGTARGZS)
	-rm -f $(BUILDMAKEFILES)
	-rm -f $(BUILDSTAMPS)
	# way to clean build results and Makefile link
	-rm -f debhello-*_build*/*.log
	-rm -f debhello-*_build*/Makefile
	-rm -f debhello-*_build*/next.dir
	-rm -f debhello-*_build*/project
	-rm -f debhello-*_build*/build
	-rm -rf debhello-*_build*/test
	# post-debmake snapshot of test
	-rm -rf debhello-*_build*/debmake
	# post-package snapshot of test
	-rm -rf debhello-*_build*/package

distclean: clean
	-rm -f $(ASCIIDOC_REF)
	-rm -f debhello-*_build*/*.slog

deps:
	# === ALL_DEPS ===
	sudo apt-get update
	sudo apt-get install $(ALL_DEPS)

prep:
	# === ALL_DIRS ===
	@ echo "$(ALL_DIRS)"| xargs -n1
	# === BUILD_DIRS ===
	@ echo "$(BUILD_DIRS)"| xargs -n1
	# === UPSTREAM_DIRS ===
	@ echo "$(UPSTREAM_DIRS)" | xargs -n1
	# === TARGZS ===
	@ echo "$(TARGZS)" | xargs -n1
	$(MAKE) $(TARGZS)
	# === ORIGTARGZS ===
	@ echo "$(ORIGTARGZS)" | xargs -n1
	$(MAKE) $(ORIGTARGZS)
	# === BUILDMAKEFILES ===
	$(MAKE) $(BUILDMAKEFILES)

asciidoc:
	# === ASCIIDOC_REF ===
	$(MAKE) $(ASCIIDOC_REF)

buildall:
	# === BUILDSTAMPS ===
	$(MAKE) $(BUILDSTAMPS)

debhello-%.tar.gz: debhello-%/README.md
	tar --exclude=debhello-$*/debian -cvzf $@ debhello-$*/

debhello_%.orig.tar.gz: debhello-%.tar.gz
	ln -sf $^ $@

debhello-%/Makefile: template/Makefile
	ln -sf ../$^ $@

debhello-%-stamp: debhello-%/Makefile
	$(MAKE) -C debhello-$*

#######################################################################
# Groom debhello-*/debian/* template files
#######################################################################
BUILD_VERS := $(patsubst debhello-%,%,$(BUILD_DIRS))
UPSTREAM_VERS := $(patsubst debhello-%,%,$(UPSTREAM_DIRS))
CHANGELOGS := $(addsuffix /debian/changelog, $(addprefix debhello-,$(UPSTREAM_VERS)))
COPYRIGHTS := $(addsuffix /debian/copyright, $(addprefix debhello-,$(UPSTREAM_VERS)))
COPYRIGHTS := $(addsuffix /debian/control, $(addprefix debhello-,$(UPSTREAM_VERS)))
READMES := $(addsuffix /debian/README.Debian, $(addprefix debhello-,$(UPSTREAM_VERS)))
WATCHS := $(addsuffix /debian/watch, $(addprefix debhello-,$(UPSTREAM_VERS)))
SRCF := $(addsuffix /debian/source/format, $(addprefix debhello-,$(UPSTREAM_VERS)))
WRAPS := $(addsuffix -wrap,$(addprefix debhello-,$(UPSTREAM_VERS)))

builds:
	# === BUILD UPSTREAM_VERS ===
	@ echo "$(BUILD_VERS)"| xargs -n1

vers:
	# === UPSTREAM_VERS ===
	@ echo "$(UPSTREAM_VERS)"| xargs -n1

groom:
	cd template ; touch * source/*
	$(MAKE) $(CHANGELOGS) $(COPYRIGHTS) $(READMES) $(WATCHS) $(SRCF) $(CONTROLS)
	# clean whitespaces in line tail (exclude some directories)
	-find . -type d \
		-regex ".*/\.git" -prune -o \
		-regex ".*/post-gettextize" -prune -o \
		-regex ".*/png" -prune -o \
	       -type f -exec sed -i -e 's/[ \t]*$$//' '{}' \;
	$(MAKE) $(WRAPS)

debhello-%/debian/changelog: template/changelog
	mkdir -p debhello-$*/debian
	sed -ne '/debhello ($*-1/,$$p' <$^ >$@

debhello-%/debian/copyright: template/copyright
	mkdir -p debhello-$*/debian
	cp -f $^ $@

debhello-%/debian/control: template/README.Debian
	mkdir -p debhello-$*/debian
	sed -i  \
		-e 's/^Section: unknown$$/Section: devel/' \
		-e 's/^Maintainer:.*$$/Maintainer: $(MAINTNM)/' \
		-e 's/debhelper-compat *( *= *[1-9][0-9]* *)/debhelper-compat (= $(DHCOMPAT))/' \
		-e 's/^Standards-Version:.*$$/Standards-Version: $(STDVER)/' \
		-e 's,^Homepage:.*$$,Homepage: $(HOMEPAGE),' \
		-e 's,^Description:.*$$,Description: Simple packaging example for debmake,' \
		-e 's,was auto-generated.*$$,is an example package.,' \
		-e 's,^ debmake(1) command provided by .*$$, (This is an example only),' \
		-e 's,^X-Python3-Version.*$$,,' \
		$@

debhello-%/debian/README.Debian: template/README.Debian
	mkdir -p debhello-$*/debian
	cp -f $^ $@

debhello-%/debian/watch: template/watch
	mkdir -p debhello-$*/debian
	cp -f $^ $@

debhello-%/debian/source/format: template/source/format
	mkdir -p debhello-$*/debian/source
	cp -f $^ $@

debhello-%-wrap:
	cd debhello-$* ; \
	wrap-and-sort

debhello-%/ASCIIDOC_REF:
	{ cd ../asciidoc ; rg --vimgrep "debhello-$*" *.txt || echo "---" ; } > $@

symlinks:
	for d in $(filter-out debhello-0.0_build-1, $(BUILD_DIRS)); do $(MAKE) -C $$d symlink ; cd - ; done

=== debian/changelog ===
debmake-doc (1.20-1) unstable; urgency=medium

  * Work-around asciidoctor docbook (missing superscript)

 -- Osamu Aoki <osamu@debian.org>  Tue, 01 Oct 2024 23:38:17 +0900

debmake-doc (1.19-1) unstable; urgency=medium

  * Don't use some xrefs generated by <<...>> in ASCIIDOC.
  * Build with asciidoctor.  Closes: #1001088
  * Address debian/compat issue.  Closes: #1075842
  * Add pt.po after fixing markups. Closes: #1053928
  * Update PO with xref/ulink/quot fixes for all PO.

 -- Osamu Aoki <osamu@debian.org>  Tue, 01 Oct 2024 00:35:13 +0900

debmake-doc (1.18-1) unstable; urgency=medium

  [ Osamu Aoki ]
  * Migrate to use asciidoctor 2
    * Major conversion and reorganization asciidoc/*.txt
    * Refine build
    * Update PO
  * Update for trixie
    * Use debmake 4.5.0
  * Rebuild examples
    * Use pyproject.toml as example

  [ Dorle Osterode ]
  * Minor improvements 12-setup and 22-rules

  [ Otto Kekäläinen ]
  * Salsa CI: 29-debconfig.txt 38-git.txt

 -- Osamu Aoki <osamu@debian.org>  Fri, 27 Sep 2024 13:37:59 +0900

debmake-doc (1.17-9) unstable; urgency=medium

  * touch-up around adduser (Closes: #1052521)

 -- Osamu Aoki <osamu@debian.org>  Fri, 10 Nov 2023 15:02:25 +0900

debmake-doc (1.17-8) unstable; urgency=medium

  * Fix missing )
  * Link to Russ's page
  * Mention "Using Git for Debian Packaging"
  * doc: mention adduser removal from chroot
  * Update PDF build.  Closes: #1024083
  * make po

 -- Osamu Aoki <osamu@debian.org>  Wed, 08 Nov 2023 13:43:09 +0900

debmake-doc (1.17-7) unstable; urgency=medium

  * make po

 -- Osamu Aoki <osamu@debian.org>  Mon, 09 May 2022 23:46:35 +0900

debmake-doc (1.17-6) unstable; urgency=medium

  * Update DE translation.

 -- Osamu Aoki <osamu@debian.org>  Wed, 04 May 2022 08:13:06 +0900

debmake-doc (1.17-5) unstable; urgency=medium

  * Update dquilt.  Closes: Bug#882809, Bug#1010402

 -- Osamu Aoki <osamu@debian.org>  Sun, 27 Feb 2022 22:19:01 +0900

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: doc
 Priority: optional
 Maintainer: Osamu Aoki <osamu@debian.org>
-Build-Depends: asciidoc,
+Build-Depends: asciidoctor,
                dblatex,
                debhelper-compat (= 13),
                dh-python,
@@ -13,7 +13,7 @@
                fonts-ipafont,
                fonts-liberation,
                fonts-wqy-zenhei,
-	       po4a,
+               po4a,
                latex-cjk-all,
                libxml2-utils,
                lmodern,
@@ -27,9 +27,10 @@
                texlive-lang-japanese,
                texlive-xetex,
                xsltproc,
-	       w3m,
+               w3m,
                zip
 Standards-Version: 4.6.0
+Rules-Requires-Root: no
 Homepage: https://salsa.debian.org/debian/debmake-doc
 Vcs-Git: https://salsa.debian.org/debian/debmake-doc.git
 Vcs-Browser: https://salsa.debian.org/debian/debmake-doc

=== debian/watch ===
version=4
opts="mode=git" \
 https://salsa.debian.org/debian/debmake-doc.git \
 refs/tags/upstream/([\d\.]+) debian
# debmake-doc is packaged as a non-native package
# 1. debian/changelog records changes with <upstream_version>-1
# 2. Temporary branch is created and commit w/o debian/* as tag=upstream/<upstream_version>
# 3. Upstream tarball generated by "git deborig"
# 4. Swich back to main branch and test build "sbuild"
# 5. dgit push-source
